#!/usr/bin/env python
# coding: utf-8

import traceback

from cyberwatch_agent.agent import Agent


def main():
    agent = None
    try:
        agent = Agent()
        agent.start()
    except KeyboardInterrupt:
        print("Interrupted by user.")
    except SystemExit:
        raise
    except:
        try:
            if agent and agent.api_client:
                print("Try to send crash report...")
                agent.api_client.crash_report(traceback.format_exc())
                print("Done.")
        except:
            print('Exception during exception handling!\nABORTING!')
            print('-' * 79)
            traceback.print_exc()
            print('-' * 79)


if __name__ == '__main__':
    main()
