#!/usr/bin/env python
# coding: utf-8

import sys
import subprocess


class SystemCommand(object):
    def __init__(self, environs):
        self.env = environs

    def execute(self, command):
        if self.env.os.Linux:
            return self._bash_execute(command)
        if self.env.os.Windows:
            return self._powershell_exec(command)
        if self.env.os.Mac:
            return self._bash_execute(command)

    @staticmethod
    def _bash_execute(command):
        args = ['/bin/bash']
        shell = subprocess.Popen(args,
                                 stdin=subprocess.PIPE,
                                 stdout=subprocess.PIPE,
                                 stderr=subprocess.STDOUT)
        output = shell.communicate(command.encode('utf-8'))[0]
        if sys.stdout.encoding is None:
            output = output.decode('ascii', errors='replace').strip()
        else:
            output = output.decode(sys.stdout.encoding).strip()
        return output, shell.returncode

    @staticmethod
    def _powershell_exec(command):
        args = ['PowerShell',
                '-NoProfile',
                '-NonInteractive',
                '-ExecutionPolicy', 'ByPass',
                '-']
        shell = subprocess.Popen(args,
                                 stdin=subprocess.PIPE,
                                 stdout=subprocess.PIPE,
                                 stderr=subprocess.STDOUT)
        output = shell.communicate(command)[0]
        if sys.stdout.encoding is None:
            output = output.decode('ascii', errors='replace').strip()
        else:
            output = output.decode(sys.stdout.encoding).strip()
        return output, shell.returncode
